unit Rechner;

{$mode objfpc}{$H+} {$INTERFACES CORBA}

interface
Type
    IAusgabeBeobachter = interface
      Procedure AktualisiereBeobachter;
    end;
    IAusgabeSender = interface
      Procedure AusgabeBeobachterRegistrieren(beobachter:IAusgabeBeobachter);
      Procedure AusgabeBeobachterAbmelden(beobachter:IAusgabeBeobachter);
      Procedure AusgabeBeobachterInformieren;
    end;

    { TRechner }

    TRechner = class(IAusgabeSender)
      private
        FEingabepuffer   : string;
        FOperatoren      : Set of Char;
        FZahlen          : Set of Char;
        FOffeneKlammern  : Byte;
        FAusgabeText     : string;
        FAusgabeZahl     : double;
        FIstErgebnis        : boolean;
        FAusgabeBeobachter : Array of IAusgabeBeobachter;
        Function IstKorrekteEingabe(zeichen : char) : Boolean;
        Procedure BerechneErgebnis;
        Procedure AusgabeBeobachterInformieren;
      public
        Constructor neu;
        //Destructor freigeben;
        Property AusgabeText   : String read FAusgabeText;
        Property AusgabeZahl : Double read FAusgabeZahl;
        Procedure EingabeAnfuegen(zeichen : char);
        Procedure EingabeLoeschen;
        Procedure AusgabeBeobachterRegistrieren(Beobachter:IAusgabeBeobachter);
        Procedure AusgabeBeobachterAbmelden(Beobachter:IAusgabeBeobachter);
        Procedure Zuruecksetzen;
        Procedure TesteBerechnung; // Später löschen!!!

    end;



implementation

uses
  Classes, SysUtils;

(* Konstruktor*)
constructor TRechner.neu;
begin
  FAusgabeText:= '0';
  FAusgabeZahl:= 0.0;
  FEingabepuffer:= '0';
  FOffeneKlammern:=0;
  FOperatoren:=['+', '-', '*', '/'];
  FZahlen:= ['0','1','2','3','4','5','6','7','8','9'];
  FIstErgebnis:=false;
  AusgabeBeobachterInformieren;
end;

Procedure TRechner.TesteBerechnung;
begin
  FEingabepuffer:='9,6*((3,5+4)*(6,2-3,1))/2,221';
  BerechneErgebnis;
end;

(* Routinen für das Einfügen und Löschen von Text*)

procedure TRechner.EingabeAnfuegen(zeichen: char);
begin

   if (IstKorrekteEingabe(zeichen)) then
     begin
       if (zeichen = '=') or (zeichen = #13) then
         begin
           BerechneErgebnis;
           Exit;
         end;
       if (FEingabepuffer = '0') then
         begin
           FEingabepuffer:=zeichen;
           FIstErgebnis:=false;
         end
       else
         FEingabepuffer:= FEingabepuffer + zeichen;
     (* Klammern zählen! *)
     if zeichen = '(' then Inc(FOffeneKlammern);
     if zeichen = ')' then Dec(FOffeneKlammern);
     FAusgabeText:=FEingabepuffer;
     { TODO : Hier noch Eingabepuffer in Zahl umwandeln, wenn Ausdruck eine Zahl ist und an FAusgabeZahl übergeben }
     AusgabeBeobachterInformieren;;
     end;
end;

procedure TRechner.EingabeLoeschen;
begin
   if Length(FEingabepuffer) > 0 then
    begin
     if FEingabepuffer[Length(FEingabepuffer)] = '(' then
       Dec(FOffeneKlammern);
     if FEingabepuffer[Length(FEingabepuffer)] = ')' then
       Inc(FOffeneKlammern);
     Delete(FEingabepuffer,Length(FEingabepuffer), 1);
    end;
  if Length(FEingabepuffer) = 0 then
     FEingabepuffer:='0';
   FAusgabeText:=FEingabepuffer;
   AusgabeBeobachterInformieren;
end;

(* Prüfroutine für die Eingaben *)

function TRechner.IstKorrekteEingabe(zeichen: char): Boolean;
var
  letztesZeichen  : char;
  FErgebnis       : Boolean;

Function AktuelleZahlHatKomma : Boolean;
var
  i : Integer;
begin
  i := Length(FEingabepuffer);
  While FEingabepuffer[i] in FZahlen Do   // Suche rückwärts das erste Zeichen, das keine Zahl ist
  begin
    if i = 1 then break;
    Dec(i);
  end;
  if FEingabepuffer[i] = ',' then
    Result := True
  else
    Result:= False;

end;

begin
  FErgebnis := False;
  if (FEingabepuffer='0') or (FEingabepuffer = '') then       // Eingabe ist erstes Zeichen überhaupt
  begin
    if (zeichen in FZahlen) or (zeichen = '(')  or (zeichen = '-') then Result:= True;
    Exit;
  end;
  letztesZeichen:=FEingabepuffer[length(FEingabepuffer)];
  if letztesZeichen in FZahlen then
    begin
      if zeichen in FZahlen then FErgebnis:=True;
      if (zeichen=',') and (Not AktuelleZahlHatKomma) then FErgebnis:=True;
      if zeichen in FOperatoren then FErgebnis:=True;
      if (zeichen=')') and (FOffeneKlammern > 0) then FErgebnis:=True;
    end;
  if letztesZeichen in FOperatoren then      // Letztes Zeichen ist ein Operator
    begin
      if zeichen in FZahlen then FErgebnis:=True;
      if (zeichen = '-') or (zeichen = '(') then FErgebnis:=True;
    end;
  if letztesZeichen = ',' then
    begin
      if zeichen in FZahlen then FErgebnis:=True;
      //Eventuell bei anderen Eingaben das Komma abschneiden und durch das letzte Zeichen ersetzen
    end;
  if letztesZeichen = '(' then
    begin
      if zeichen in FZahlen then FErgebnis:=True;
      if (zeichen = '-') or (zeichen = '(') then FErgebnis:=True;
    end;
  if letztesZeichen = ')' then
    begin
      if zeichen in FOperatoren then FErgebnis:=True;
      if (zeichen = ')') and (FOffeneKlammern > 0) then FErgebnis:=True;
    end;
  if (zeichen = '=') or (zeichen = #13) then  //#13 ist Entertaste
    if (letztesZeichen in FZahlen) or (letztesZeichen = ')') then FErgebnis:=True;
  IstKorrekteEingabe:=FErgebnis;
end;

(*Ergebnisberechnung*)
Procedure TRechner.BerechneErgebnis;
const
  div0Fehler = 'Error:Div/0';
var
  zwischenpuffer:string;    (*Speichert den gerade zu berechnenden Ausdruck*)
  start, ende:Integer;   (* speichert den die Position des gerade zu
                           berechnenden Ausdrucks im String, um diesen Teil
                           später ersetzen zu können *)
  i: Integer;

Function wert(operand1, operand2: double; operatorSymbol:char):string;
  begin
    case operatorSymbol of
     '+': wert:= FloatToStr(operand1 + operand2);
     '-': wert:= FloatToStr(operand1 - operand2);
     '*': wert:= FloatToStr(operand1 * operand2);
     '/': wert:= FloatToStr(operand1 / operand2)
     end;

  end;  // Ende Function wert...
Procedure zerlegeAusdruck(ausdruck:string; out operand1, operand2:double;
                                           out operatorSymbol:char);
var
  i,j,weitererOperator: Integer;
begin

  for i := 1 to Length(ausdruck) do
  begin
   if ausdruck[i] in FOperatoren then
      begin
        operand1 := StrToFloat(Trim(ausdruck[1..(i-1)]));
        operatorSymbol:=ausdruck[i];
        weitererOperator:=-1;
        For j := i+1 to Length(ausdruck) do
        begin
         if ausdruck[j] in FOperatoren then
           begin
             weitererOperator:=j;
             break;
           end;
        end;
        if weitererOperator = -1 then
          operand2 := StrToFloat(Trim(ausdruck[(i+1)..Length(ausdruck)]))
        else
          operand2 := StrToFloat(Trim(ausdruck[i+1..(weitererOperator-1)]));

      end;
  end;
end; // Ende Procedure zerlegeAusdruck...

Function ErsetzeAusdruecke(formel:string):string;

var
  operand1, operand2:double;
  rechenoperator:char;
  i:Integer;
  beginnFormel, endeFormel:Integer;
  ErsatzAusdruck, neueFormel:String;
Procedure AnfangUndEndeFormel;
var
  j:Integer;
begin
  //Anfang Ausdruck links suchen
        for j := i-1 downto 1 do
        begin
          beginnFormel:=1; // Die Formel beginnt spätestens am Anfang :-)
          if formel[j] in FOperatoren then
             begin
               beginnFormel:=j+1;
               break;
             end;
        end;
        // Ende Ausdruck rechts suchen
        For j := i+1 to Length(formel) do
        begin
          endeFormel:= Length(formel);
          if formel[j] in FOperatoren then
            begin
              endeFormel:=j-1;
              break;
            end;

        end;
end;

begin
  neueFormel:=formel;
  (* Punktrechnungen suchen *)
  while (Pos('*',formel) <> 0) or  (Pos('/',formel) <> 0) do
  begin
    for i:=1 to Length(formel) do
      begin
        if (formel[i] = '*') or (formel[i] = '/') then
          begin
            AnfangUndEndeFormel;
            zerlegeAusdruck(formel[beginnFormel..endeFormel],
                operand1,operand2,rechenoperator);
            if (rechenoperator = '/') and (operand2 = 0) then
              begin
                Result := div0Fehler;
                exit;
              end;
            neueFormel:=StringReplace(formel,formel[beginnFormel..endeFormel],
                          wert(operand1,operand2,formel[i]),[rfReplaceAll]);
            formel:=neueFormel;
            break;
          end;
      end;
  end;

  (* Strichrechnung suchen *)
  while (Pos('+',formel) <> 0) or (Pos('-',formel) <> 0) do
  begin
    for i:=1 to Length(formel) do
      begin
        if (formel[i] = '+') or (formel[i] = '-') then
          begin
            AnfangUndEndeFormel;
            zerlegeAusdruck(formel[beginnFormel..endeFormel],
                operand1,operand2,rechenoperator);
            ErsatzAusdruck:=wert(operand1, operand2,formel[i]);
            neueFormel:=StringReplace(formel,formel[beginnFormel..endeFormel],ErsatzAusdruck,[rfReplaceAll]);
            formel:=neueFormel;
          end;
      end;
  end;
  Result:=formel;
end;



(*** Eigentlicher Beginn von BerechneErgebnis ***)
begin
  // Innere Klammer suchen
    start:=  Pos('(', FEingabepuffer);
    while start <> 0 do begin
      For i:= start+1 to Length(FEingabepuffer) do
      begin
        if FEingabepuffer[i] = '(' then
          begin
            start:= i; // neue öffnende Klammer gefunden
            zwischenpuffer:='';
          end;

        if FEingabepuffer[i] = ')' then  // Inneren Klammerausdruck gefunden
          begin
            ende:=i;
            zwischenpuffer:=ErsetzeAusdruecke(zwischenpuffer);
            if zwischenpuffer = div0Fehler then
              begin
                FAusgabeText:=div0Fehler;
                FEingabepuffer:='0';
                AusgabeBeobachterInformieren;
                Exit;
              end;
            FEingabepuffer:= StringReplace(FEingabepuffer,FEingabepuffer[start..ende],zwischenpuffer,[rfReplaceAll]);
            start:= Pos('(', FEingabepuffer);
            zwischenpuffer:='';
            break;
          end;
        if (FEingabepuffer[i] <> '(') and (FEingabepuffer[i] <> ')') then
           zwischenpuffer:=zwischenpuffer+FEingabepuffer[i];
      end;

    end;
  // So, jetzt sind alle Klammern ersetzt. Nu die Restformel durchparsen
  // Dann Ergebnis ausgeben
  FEingabepuffer:= ErsetzeAusdruecke(FEingabepuffer);
  FAusgabeText:=FEingabepuffer;
  AusgabeBeobachterInformieren;
  FIstErgebnis:=true;
end;

(* Rechner auf Null zurücksetzen *)
Procedure TRechner.Zuruecksetzen;
begin
  FEingabepuffer:='0';
  FAusgabeText:='0';
  AusgabeBeobachterInformieren;
end;

(* Routinen für IAusgabeSender  *)
procedure TRechner.AusgabeBeobachterRegistrieren(Beobachter: IAusgabeBeobachter
  );
var
  laenge:Integer;
begin
  laenge := length(FAusgabeBeobachter);
  SetLength(FAusgabeBeobachter, laenge+1);
  FAusgabeBeobachter[laenge] := Beobachter;
end;

procedure TRechner.AusgabeBeobachterAbmelden(Beobachter: IAusgabeBeobachter);
var
  laenge,i,j:Integer;
begin
  laenge := High(FAusgabeBeobachter);
  for i:=0 to laenge do
  begin
    if FAusgabeBeobachter[i] = Beobachter then
    begin
      for j:=i to (laenge-1) do
        FAusgabeBeobachter[j]:=FAusgabeBeobachter[j+1];
      SetLength(FAusgabeBeobachter, laenge-1);
      break;
    end;
  end;
end;

procedure TRechner.AusgabeBeobachterInformieren;
var
  i:integer;
begin
  for i:=0 to High(FAusgabeBeobachter) do
    FAusgabeBeobachter[i].AktualisiereBeobachter;
end;

end.



