unit Rechnerformular;

{$mode objfpc}{$H+} {$INTERFACES CORBA}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Rechner, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm,IAusgabeBeobachter)
    AnzeigeLabel: TLabel;
    Button1: TButton;
    Button0: TButton;
    ButtonKlammerAuf: TButton;
    ButtonKlammerZu: TButton;
    ButtonBackSpace: TButton;
    ButtonKomma: TButton;
    ButtonPlus: TButton;
    ButtonMinus: TButton;
    ButtonMal: TButton;
    ButtonGeteilt: TButton;
    ButtonGleich: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    ButtonZuruecksetzen: TButton;

    procedure ButtonBackSpaceClick(Sender: TObject);
    procedure ButtonTestClick(Sender: TObject);
    procedure ButtonZuruecksetzenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    //procedure FormUTF8KeyPress(Sender: TObject; var UTF8Key: TUTF8Char);
    private
    { private declarations }
    Rechner : TRechner;     // Separate Klasse, die die Funktionalität kapselt
    Procedure eingabeErfolgt(Sender:TObject);

  public
    { public declarations }
    Procedure AktualisiereBeobachter;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Rechner := TRechner.neu;
  Rechner.AusgabeBeobachterRegistrieren(Self as IAusgabeBeobachter);
  Button0.OnClick:=@eingabeErfolgt;
  Button1.OnClick:=@eingabeErfolgt;
  Button2.OnClick:=@eingabeErfolgt;
  Button3.OnClick:=@eingabeErfolgt;
  Button4.OnClick:=@eingabeErfolgt;
  Button5.OnClick:=@eingabeErfolgt;
  Button6.OnClick:=@eingabeErfolgt;
  Button7.OnClick:=@eingabeErfolgt;
  Button8.OnClick:=@eingabeErfolgt;
  Button9.OnClick:=@eingabeErfolgt;
  ButtonGleich.OnClick:=@eingabeErfolgt;
  ButtonPlus.OnClick:=@eingabeErfolgt;
  ButtonMinus.OnClick:=@eingabeErfolgt;
  ButtonMal.OnClick:=@eingabeErfolgt;
  ButtonGeteilt.OnClick:=@eingabeErfolgt;
  ButtonKomma.OnClick:=@eingabeErfolgt;
  ButtonKlammerAuf.OnClick:=@eingabeErfolgt;
  ButtonKlammerZu.OnClick:=@eingabeErfolgt;
  // ButtonZuruecksetzen.OnClick:=@eingabeErfolgt;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Rechner.free;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: char);
begin
  case Key of
    #8: Rechner.EingabeLoeschen;
    'c', 'C',#27: Rechner.Zuruecksetzen;
  else
    Rechner.EingabeAnfuegen(Key);
  end;
  Key:=#0;
end;

procedure TForm1.ButtonBackSpaceClick(Sender: TObject);
begin
  Rechner.EingabeLoeschen;
end;

procedure TForm1.ButtonTestClick(Sender: TObject);
begin
  Rechner.TesteBerechnung;
end;

procedure TForm1.ButtonZuruecksetzenClick(Sender: TObject);
begin
  Rechner.Zuruecksetzen;
end;

//procedure TForm1.FormUTF8KeyPress(Sender: TObject; var UTF8Key: TUTF8Char);
//var temp : WideString;
//begin
//    case UTF8Key of
//    #8: Rechner.EingabeLoeschen;
//    'c','C': Rechner.Zuruecksetzen;
//    else
//      begin
//        temp := UTF8Decode(UTF8Key);
//        Rechner.EingabeAnfuegen(temp[1]);  // Die Funktion erwartet einen Char!
//      end;
//
//    end;
//end;






procedure TForm1.eingabeErfolgt(Sender:TObject);
var
  zeichen:char;
begin
  if Sender is TButton then
    begin
      if (Sender as TButton).Caption = 'Del' then
        zeichen := #8
      else
       zeichen := (Sender as TButton).Caption[1];
    end;



  Rechner.EingabeAnfuegen(zeichen);
end;

Procedure TForm1.AktualisiereBeobachter;
begin
   AnzeigeLabel.Caption:=Rechner.AusgabeText;
end;


end.

